blob: 3671f3433e82f7c54e09e90b411a63f1f068210d [file] [log] [blame]
Junio C Hamano0fec0822005-07-23 17:54:26 -07001#!/bin/sh
2#
Junio C Hamano0fec0822005-07-23 17:54:26 -07003
4usage () {
Michal Ostrowski96b086d2006-01-20 13:38:16 -05005 echo >&2 "usage: $0 [--heads] [--tags] [-u|--upload-pack <upload-pack>]"
6 echo >&2 " <repository> <refs>..."
Junio C Hamano0fec0822005-07-23 17:54:26 -07007 exit 1;
8}
9
Junio C Hamano1abacf32005-11-27 23:15:02 -080010die () {
11 echo >&2 "$*"
12 exit 1
13}
14
Michal Ostrowski96b086d2006-01-20 13:38:16 -050015exec=
Junio C Hamano0fec0822005-07-23 17:54:26 -070016while case "$#" in 0) break;; esac
17do
18 case "$1" in
19 -h|--h|--he|--hea|--head|--heads)
20 heads=heads; shift ;;
Junio C Hamano0fec0822005-07-23 17:54:26 -070021 -t|--t|--ta|--tag|--tags)
22 tags=tags; shift ;;
Michal Ostrowski96b086d2006-01-20 13:38:16 -050023 -u|--u|--up|--upl|--uploa|--upload|--upload-|--upload-p|--upload-pa|\
24 --upload-pac|--upload-pack)
25 shift
Junio C Hamanoae1dffc2007-01-23 00:51:53 -080026 exec="--upload-pack=$1"
27 shift;;
28 -u=*|--u=*|--up=*|--upl=*|--uplo=*|--uploa=*|--upload=*|\
29 --upload-=*|--upload-p=*|--upload-pa=*|--upload-pac=*|--upload-pack=*)
Shawn O. Pearce4a91a1f2007-01-30 13:11:49 -050030 exec=--upload-pack=$(expr "z$1" : 'z-[^=]*=\(.*\)')
Michal Ostrowski96b086d2006-01-20 13:38:16 -050031 shift;;
Junio C Hamano0fec0822005-07-23 17:54:26 -070032 --)
33 shift; break ;;
34 -*)
35 usage ;;
36 *)
37 break ;;
38 esac
39done
40
Junio C Hamano972b6fe2005-08-08 01:20:03 -070041case "$#" in 0) usage ;; esac
Junio C Hamano0fec0822005-07-23 17:54:26 -070042
43case ",$heads,$tags," in
44,,,) heads=heads tags=tags other=other ;;
45esac
46
Junio C Hamano215a7ad2005-09-07 17:26:23 -070047. git-parse-remote
Junio C Hamanoe0bfc812005-08-20 02:57:26 -070048peek_repo="$(get_remote_url "$@")"
Junio C Hamano972b6fe2005-08-08 01:20:03 -070049shift
Junio C Hamano0fec0822005-07-23 17:54:26 -070050
51tmp=.ls-remote-$$
52trap "rm -fr $tmp-*" 0 1 2 3 15
53tmpdir=$tmp-d
54
55case "$peek_repo" in
Sasha Khapyorsky38529e22006-09-14 05:24:04 +030056http://* | https://* | ftp://* )
Junio C Hamano0fec0822005-07-23 17:54:26 -070057 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
58 curl_extra_args="-k"
59 fi
Sasha Khapyorsky3ea099d2006-09-29 03:10:44 +030060 if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
Junio C Hamano5be60072007-07-02 22:52:14 -070061 "`git config --bool http.noEPSV`" = true ]; then
Sasha Khapyorsky3ea099d2006-09-29 03:10:44 +030062 curl_extra_args="${curl_extra_args} --disable-epsv"
63 fi
Nick Hengeveld7fa8ddd2006-04-04 11:01:30 -070064 curl -nsf $curl_extra_args --header "Pragma: no-cache" "$peek_repo/info/refs" ||
Junio C Hamanoa5cd85e2005-09-13 13:16:45 -070065 echo "failed slurping"
Junio C Hamano0fec0822005-07-23 17:54:26 -070066 ;;
67
68rsync://* )
Junio C Hamanoe686eba2006-05-24 21:36:14 -070069 mkdir $tmpdir &&
70 rsync -rlq "$peek_repo/HEAD" $tmpdir &&
Junio C Hamanoa5cd85e2005-09-13 13:16:45 -070071 rsync -rq "$peek_repo/refs" $tmpdir || {
72 echo "failed slurping"
73 exit
74 }
Junio C Hamanoe686eba2006-05-24 21:36:14 -070075 head=$(cat "$tmpdir/HEAD") &&
76 case "$head" in
77 ref:' '*)
78 head=$(expr "z$head" : 'zref: \(.*\)') &&
79 head=$(cat "$tmpdir/$head") || exit
80 esac &&
81 echo "$head HEAD"
Junio C Hamano0fec0822005-07-23 17:54:26 -070082 (cd $tmpdir && find refs -type f) |
83 while read path
84 do
85 cat "$tmpdir/$path" | tr -d '\012'
86 echo " $path"
87 done &&
88 rm -fr $tmpdir
89 ;;
90
91* )
Johannes Schindelin2e0afaf2007-02-22 01:59:14 +010092 if test -f "$peek_repo" ; then
93 git bundle list-heads "$peek_repo" ||
Junio C Hamanoa5cd85e2005-09-13 13:16:45 -070094 echo "failed slurping"
Johannes Schindelin2e0afaf2007-02-22 01:59:14 +010095 else
96 git-peek-remote $exec "$peek_repo" ||
97 echo "failed slurping"
98 fi
Junio C Hamano0fec0822005-07-23 17:54:26 -070099 ;;
100esac |
Junio C Hamano972b6fe2005-08-08 01:20:03 -0700101sort -t ' ' -k 2 |
Junio C Hamano0fec0822005-07-23 17:54:26 -0700102while read sha1 path
103do
Junio C Hamanoa5cd85e2005-09-13 13:16:45 -0700104 case "$sha1" in
105 failed)
Nicolas Pitreb3d98992006-12-18 15:16:58 -0500106 exit 1 ;;
Junio C Hamanoa5cd85e2005-09-13 13:16:45 -0700107 esac
Junio C Hamano0fec0822005-07-23 17:54:26 -0700108 case "$path" in
109 refs/heads/*)
110 group=heads ;;
111 refs/tags/*)
112 group=tags ;;
113 *)
114 group=other ;;
115 esac
116 case ",$heads,$tags,$other," in
117 *,$group,*)
118 ;;
119 *)
120 continue;;
121 esac
Junio C Hamano972b6fe2005-08-08 01:20:03 -0700122 case "$#" in
123 0)
124 match=yes ;;
125 *)
126 match=no
127 for pat
128 do
129 case "/$path" in
130 */$pat )
131 match=yes
132 break ;;
133 esac
134 done
Junio C Hamano0fec0822005-07-23 17:54:26 -0700135 esac
Junio C Hamano972b6fe2005-08-08 01:20:03 -0700136 case "$match" in
137 no)
138 continue ;;
139 esac
140 echo "$sha1 $path"
Junio C Hamano0fec0822005-07-23 17:54:26 -0700141done